#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_constant_managers4xi.py">
#<abstract4xi abstract = "tests constant_managers4xi"/>
#<verify4xi verification = "10" target = "constant_managers4xi.py"/>
#<contextualize4xi context = "__init__.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_constant_managers4xi',
            'print_trace4xi',
            'set_trace4xi'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from constant_managers4xi import ConstantManagers4Xi
from constant_managers4xi import init_allconstants_managers4xi
from constant_managers4xi import get_allconstants_managers4xi
from constant_managers4xi import set_allconstants_managers4xi

from constant_managers4xi import constant_managers4xi
from constant_managers4xi import init_backlog_manager4xi
from constant_managers4xi import set_backlog_manager4xi
from constant_managers4xi import get_backlog_manager4xi
from constant_managers4xi import init_clear_manager4xi
from constant_managers4xi import set_clear_manager4xi
from constant_managers4xi import get_clear_manager4xi
from constant_managers4xi import init_create_manager4xi
from constant_managers4xi import set_create_manager4xi
from constant_managers4xi import get_create_manager4xi
from constant_managers4xi import init_debug_info_manager4xi
from constant_managers4xi import set_debug_info_manager4xi
from constant_managers4xi import get_debug_info_manager4xi
from constant_managers4xi import init_dummy_manager4xi
from constant_managers4xi import set_dummy_manager4xi
from constant_managers4xi import get_dummy_manager4xi
from constant_managers4xi import init_error_manager4xi
from constant_managers4xi import set_error_manager4xi
from constant_managers4xi import get_error_manager4xi
from constant_managers4xi import init_exitpriority_manager4xi
from constant_managers4xi import set_exitpriority_manager4xi
from constant_managers4xi import get_exitpriority_manager4xi
from constant_managers4xi import init_getvalue_manager4xi
from constant_managers4xi import set_getvalue_manager4xi
from constant_managers4xi import get_getvalue_manager4xi
from constant_managers4xi import init_id_manager4xi
from constant_managers4xi import set_id_manager4xi
from constant_managers4xi import get_id_manager4xi
from constant_managers4xi import init_initial_manager4xi
from constant_managers4xi import set_initial_manager4xi
from constant_managers4xi import get_initial_manager4xi
from constant_managers4xi import init_is_set_manager4xi
from constant_managers4xi import set_is_set_manager4xi
from constant_managers4xi import get_is_set_manager4xi
from constant_managers4xi import init_number_of_objects_manager4xi
from constant_managers4xi import set_number_of_objects_manager4xi
from constant_managers4xi import get_number_of_objects_manager4xi
from constant_managers4xi import init_pickle_manager4xi
from constant_managers4xi import set_pickle_manager4xi
from constant_managers4xi import get_pickle_manager4xi
from constant_managers4xi import init_proxy_manager4xi
from constant_managers4xi import set_proxy_manager4xi
from constant_managers4xi import get_proxy_manager4xi
from constant_managers4xi import init_return_manager4xi
from constant_managers4xi import set_return_manager4xi
from constant_managers4xi import get_return_manager4xi
from constant_managers4xi import init_set_manager4xi
from constant_managers4xi import set_set_manager4xi
from constant_managers4xi import get_set_manager4xi
from constant_managers4xi import init_shutdown_manager4xi
from constant_managers4xi import set_shutdown_manager4xi
from constant_managers4xi import get_shutdown_manager4xi
from constant_managers4xi import init_started_manager4xi
from constant_managers4xi import set_started_manager4xi
from constant_managers4xi import get_started_manager4xi
from constant_managers4xi import init_stop_manager4xi
from constant_managers4xi import set_stop_manager4xi
from constant_managers4xi import get_stop_manager4xi
from constant_managers4xi import init_traceback_manager4xi
from constant_managers4xi import set_traceback_manager4xi
from constant_managers4xi import get_traceback_manager4xi
from constant_managers4xi import init_typeid_manager4xi
from constant_managers4xi import set_typeid_manager4xi 
from constant_managers4xi import get_typeid_manager4xi
from constant_managers4xi import init_unserializable_manager4xi
from constant_managers4xi import set_unserializable_manager4xi
from constant_managers4xi import get_unserializable_manager4xi
from constant_managers4xi import init_value_manager4xi
from constant_managers4xi import set_value_manager4xi
from constant_managers4xi import get_value_manager4xi
from constant_managers4xi import init_wait_manager4xi
from constant_managers4xi import set_wait_manager4xi
from constant_managers4xi import get_wait_manager4xi
from constant_managers4xi import init_26pppppppp4xi
from constant_managers4xi import set_26pppppppp4xi
from constant_managers4xi import get_26pppppppp4xi
from constant_managers4xi import init_27pppppppp4xi
from constant_managers4xi import set_27pppppppp4xi
from constant_managers4xi import get_27pppppppp4xi
from constant_managers4xi import init_28pppppppp4xi
from constant_managers4xi import set_28pppppppp4xi
from constant_managers4xi import get_28pppppppp4xi
from constant_managers4xi import init_29pppppppp4xi
from constant_managers4xi import set_29pppppppp4xi
from constant_managers4xi import get_29pppppppp4xi
from constant_managers4xi import init_30pppppppp4xi
from constant_managers4xi import set_30pppppppp4xi
from constant_managers4xi import get_30pppppppp4xi
from constant_managers4xi import init_31pppppppp4xi
from constant_managers4xi import set_31pppppppp4xi
from constant_managers4xi import get_31pppppppp4xi
from constant_managers4xi import init_32pppppppp4xi
from constant_managers4xi import set_32pppppppp4xi
from constant_managers4xi import get_32pppppppp4xi
from constant_managers4xi import init_33pppppppp4xi
from constant_managers4xi import set_33pppppppp4xi
from constant_managers4xi import get_33pppppppp4xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'constant_managers4xi': 'NACK4TRACE',
         'ConstantManagers4Xi': 'NACK4TRACE',
         'init_allconstants_managers4xi': 'NACK4TRACE',
         'get_allconstants_managers4xi': 'NACK4TRACE',
         'set_allconstants_managers4xi': 'NACK4TRACE',
         'init_wait_manager4xi': 'NACK4TRACE',
         'set_wait_manager4xi': 'NACK4TRACE',
         'get_wait_manager4xi': 'NACK4TRACE',
         'init_value_manager4xi': 'NACK4TRACE',
         'set_value_manager4xi': 'NACK4TRACE',
         'get_value_manager4xi': 'NACK4TRACE',
         'init_unserializable_manager4xi': 'NACK4TRACE',
         'set_unserializable_manager4xi': 'NACK4TRACE',
         'get_unserializable_manager4xi': 'NACK4TRACE',
         'init_typeid_manager4xi': 'NACK4TRACE',
         'set_typeid_manager4xi': 'NACK4TRACE',
         'get_typeid_manager4xi': 'NACK4TRACE',
         'init_traceback_manager4xi': 'NACK4TRACE',
         'set_traceback_manager4xi': 'NACK4TRACE',
         'get_traceback_manager4xi': 'NACK4TRACE',
         'init_stop_manager4xi': 'NACK4TRACE',
         'set_stop_manager4xi': 'NACK4TRACE',
         'get_stop_manager4xi': 'NACK4TRACE',
         'init_started_manager4xi': 'NACK4TRACE',
         'set_started_manager4xi': 'NACK4TRACE',
         'get_started_manager4xi': 'NACK4TRACE',
         'init_shutdown_manager4xi': 'NACK4TRACE',
         'set_shutdown_manager4xi': 'NACK4TRACE',
         'get_shutdown_manager4xi': 'NACK4TRACE',
         'init_set_manager4xi': 'NACK4TRACE',
         'set_set_manager4xi': 'NACK4TRACE',
         'get_set_manager4xi': 'NACK4TRACE',
         'init_return_manager4xi': 'NACK4TRACE',
         'set_return_manager4xi': 'NACK4TRACE',
         'get_return_manager4xi': 'NACK4TRACE',
         'init_proxy_manager4xi': 'NACK4TRACE',
         'set_proxy_manager4xi': 'NACK4TRACE',
         'get_proxy_manager4xi': 'NACK4TRACE',
         'init_pickle_manager4xi': 'NACK4TRACE',
         'set_pickle_manager4xi': 'NACK4TRACE',
         'get_pickle_manager4xi': 'NACK4TRACE',
         'init_number_of_objects_manager4xi': 'NACK4TRACE',
         'set_number_of_objects_manager4xi': 'NACK4TRACE',
         'get_number_of_objects_manager4xi': 'NACK4TRACE',
         'init_is_set_manager4xi': 'NACK4TRACE',
         'set_is_set_manager4xi': 'NACK4TRACE',
         'get_is_set_manager4xi': 'NACK4TRACE',
         'init_initial_manager4xi': 'NACK4TRACE',
         'set_initial_manager4xi': 'NACK4TRACE',
         'get_initial_manager4xi': 'NACK4TRACE',
         'init_id_manager4xi': 'NACK4TRACE',
         'set_id_manager4xi': 'NACK4TRACE',
         'get_id_manager4xi': 'NACK4TRACE',
         'init_getvalue_manager4xi': 'NACK4TRACE',
         'set_getvalue_manager4xi': 'NACK4TRACE',
         'get_getvalue_manager4xi': 'NACK4TRACE',
         'init_exitpriority_manager4xi': 'NACK4TRACE',
         'set_exitpriority_manager4xi': 'NACK4TRACE',
         'get_exitpriority_manager4xi': 'NACK4TRACE',
         'init_error_manager4xi': 'NACK4TRACE',
         'set_error_manager4xi': 'NACK4TRACE',
         'get_error_manager4xi': 'NACK4TRACE',
         'init_dummy_manager4xi': 'NACK4TRACE',
         'set_dummy_manager4xi': 'NACK4TRACE',
         'get_dummy_manager4xi': 'NACK4TRACE',
         'init_debug_info_manager4xi': 'NACK4TRACE',
         'set_debug_info_manager4xi': 'NACK4TRACE',
         'get_debug_info_manager4xi': 'NACK4TRACE',
         'init_create_manager4xi': 'NACK4TRACE',
         'set_create_manager4xi': 'NACK4TRACE',
         'get_create_manager4xi': 'NACK4TRACE',
         'init_clear_manager4xi': 'NACK4TRACE',
         'set_clear_manager4xi': 'NACK4TRACE',
         'get_clear_manager4xi': 'NACK4TRACE',
         'init_backlog_manager4xi': 'NACK4TRACE',
         'set_backlog_manager4xi': 'NACK4TRACE',
         'get_backlog_manager4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
     
#</function4xi>           
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   XML trace of testing constant_managers4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-constant-managers4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing constants in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Constants sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-constant-managers4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for constants in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-constant-managers4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for constants in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of system constant.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
        
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-constant-managers4xi" usage = "
#   testing constant_managers4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_constant_managers4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A1/33) OF TEST_CONSTANT_CONNECTION4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        
   
        # ---------------------------------------------------------------------------------------------
        # PHASE I: get values without initialize                         
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE I: get values without initialize")
        time2xi = time4xi()
        print(time2xi)   
      
        print("skipped PHASE I now: proved in different test that you have to initialize before get")
    
    
        
         
        # ---------------------------------------------------------------------------------------------
        # PHASE II: INITIALIZE with functions                             
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE II: INITIALIZE with init functions") 
        time2xi = time4xi()
        print(time2xi)
       
        #1
        init_backlog_manager4xi(50)
        init_clear_manager4xi('clear_first')
        init_create_manager4xi('create_first')  
        init_debug_info_manager4xi('debug_info_first')
        init_dummy_manager4xi('dummy_first')
        init_error_manager4xi('#ERROR_first')
        init_exitpriority_manager4xi(100)
        init_getvalue_manager4xi('#GETVALUE_first')
        init_id_manager4xi('id_first')
        #11
        init_initial_manager4xi(0)
        init_is_set_manager4xi('is_set_first')
        init_number_of_objects_manager4xi('number_of_objects_first')
        init_pickle_manager4xi('pickle_first')
        init_proxy_manager4xi('#PROXY_first')
        init_return_manager4xi('#RETURN_first')
        init_set_manager4xi('set_first')
        init_shutdown_manager4xi(20)
        init_started_manager4xi(10)
        #20
        init_stop_manager4xi(9990)
        init_traceback_manager4xi('#TRACEBACK_first')
        init_typeid_manager4xi('typeid_first')
        init_unserializable_manager4xi('#UNSERIALIZABLE_first')
        init_value_manager4xi(init_value_manager4xi_param = ['value_first'])
        init_wait_manager4xi('wait_first')
        init_26pppppppp4xi('260') 
        init_27pppppppp4xi('270') 
        init_28pppppppp4xi('280') 
        init_29pppppppp4xi('290') 
        init_30pppppppp4xi('300') 
        init_31pppppppp4xi('310') 
        init_32pppppppp4xi('320') 
        init_33pppppppp4xi('330')  
        print(get_allconstants_managers4xi()) 
        print("done init with init functions")
    
    
        
        # ---------------------------------------------------------------------------------------------
        # SET with functions                             
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        time2xi = time4xi()
        print(time2xi)
        #1
        set_backlog_manager4xi(52)
        set_clear_manager4xi('clear_new')
        set_create_manager4xi('create_new')  
        set_debug_info_manager4xi('debug_info_new')
        set_dummy_manager4xi('dummy_new')
        set_error_manager4xi('#ERROR_new')
        set_exitpriority_manager4xi(102)
        set_getvalue_manager4xi('#GETVALUE_new')
        set_id_manager4xi('id_new')
        #11
        set_initial_manager4xi(2)
        set_is_set_manager4xi('is_set_new')
        set_number_of_objects_manager4xi('number_of_objects_new')
        set_pickle_manager4xi('pickle_new')
        set_proxy_manager4xi('#PROXY_new')
        set_return_manager4xi('#RETURN_new')
        set_set_manager4xi('set_new')
        set_shutdown_manager4xi(22)
        set_started_manager4xi(12)
        #20
        set_stop_manager4xi(9992)
        set_traceback_manager4xi('#TRACEBACK_new')
        set_typeid_manager4xi('typeid_new')
        set_unserializable_manager4xi('#UNSERIALIZABLE_new')
        set_value_manager4xi(set_value_manager4xi_param = ['value_new'])
        set_wait_manager4xi('wait_new')
        set_26pppppppp4xi('262') 
        set_27pppppppp4xi('272') 
        set_28pppppppp4xi('282') 
        set_29pppppppp4xi('292') 
        set_30pppppppp4xi('302') 
        set_31pppppppp4xi('312') 
        set_32pppppppp4xi('322') 
        set_33pppppppp4xi('332')  
        print(get_allconstants_managers4xi()) 
        print("done set with a set function")
    
        # ---------------------------------------------------------------------------------------------
        # GET each individually                             
        # ---------------------------------------------------------------------------------------------
    
        print('~' *33)
        time2xi = time4xi()
        print(time2xi)
        #1
        print(get_backlog_manager4xi())
        print(get_clear_manager4xi())
        print(get_create_manager4xi())  
        print(get_debug_info_manager4xi())
        print(get_dummy_manager4xi())
        print(get_error_manager4xi())
        print(get_exitpriority_manager4xi())
        print(get_getvalue_manager4xi())
        print(get_id_manager4xi())
        #11
        print(get_initial_manager4xi())
        print(get_is_set_manager4xi())
        print(get_number_of_objects_manager4xi())
        print(get_pickle_manager4xi())
        print(get_proxy_manager4xi())
        print(get_return_manager4xi())
        print(get_set_manager4xi())
        print(get_shutdown_manager4xi())
        print(get_started_manager4xi())
        #20
        print(get_stop_manager4xi())
        print(get_traceback_manager4xi())
        print(get_typeid_manager4xi())
        print(get_unserializable_manager4xi())
        print(get_value_manager4xi())
        print(get_wait_manager4xi())
        print(get_26pppppppp4xi()) 
        print(get_27pppppppp4xi()) 
        print(get_28pppppppp4xi()) 
        print(get_29pppppppp4xi()) 
        print(get_30pppppppp4xi()) 
        print(get_31pppppppp4xi()) 
        print(get_32pppppppp4xi()) 
        print(get_33pppppppp4xi())  
        print("done each get with a get function")
        
    
        # ---------------------------------------------------------------------------------------------
        # PHASE III: use class                              
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE III: CLASS methods are being used") 
        time2xi = time4xi()
        print(time2xi)
        
        # ---------------------------------------------------------------------------------------------
        # Step 1/XX
        # ---------------------------------------------------------------------------------------------
        cm2xi = ConstantManagers4Xi()
        print("PHASE III Step 1/7 created cm2xi object of ConstantManagers4Xi class")
        
        # ---------------------------------------------------------------------------------------------
        print(cm2xi.get_all())
        print("PHASE III/ Step 2/7 done: got all after object creation done")
        
        
       
        # ---------------------------------------------------------------------------------------------
        # SET and GET ALL by using class objects set_all and get_all methods                              
        # ---------------------------------------------------------------------------------------------
        print("PHASE III/  Step 3/7a calling set all with object cm2xi: ")
        
        cm2xi.set_all()
        print("PHASE III/  Step 3/7b done: set all with defaults")
        
        print(cm2xi.get_all())
        print("PHASE III/  Step 3/7c got all")
            
        # ---------------------------------------------------------------------------------------------
        # INIT and GET all                              
        # ---------------------------------------------------------------------------------------------
        cm2xi.init_all()
        print(cm2xi.get_all())
        print("PHASE III/ Step 4/7 INIT and GET by using ALL init and set method done!")
    
        # ---------------------------------------------------------------------------------------------
        # SET each individually                             
        # ---------------------------------------------------------------------------------------------
        print("PHASE III/ Step 5/7 SET each individually")
        print('~' *33)
        time2xi = time4xi()
        print(time2xi)
        
        #1
        cm2xi.set_backlog(52)
        cm2xi.set_clear('clear_new')
        cm2xi.set_create('create_new')  
        cm2xi.set_debug_info('debug_info_new')
        cm2xi.set_dummy('dummy_new')
        cm2xi.set_error('#ERROR_new')
        cm2xi.set_exitpriority(102)
        cm2xi.set_getvalue('#GETVALUE_new')
        cm2xi.set_id('id_new')
        #11
        cm2xi.set_initial(2)
        cm2xi.set_is_set('is_set_new')
        cm2xi.set_number_of_objects('number_of_objects_new')
        cm2xi.set_pickle('pickle_new')
        cm2xi.set_proxy('#PROXY_new')
        cm2xi.set_return('#RETURN_new')
        cm2xi.set_set('set_new')
        cm2xi.set_shutdown(22)
        cm2xi.set_started(12)
        #20
        cm2xi.set_stop(9992)
        cm2xi.set_traceback('#TRACEBACK_new')
        cm2xi.set_typeid('typeid_new')
        cm2xi.set_unserializable('#UNSERIALIZABLE_new')
        cm2xi.set_value(set_value_param = ['value_new'])
        cm2xi.set_wait('wait_new')
        cm2xi.set_26pppppppp('262') 
        cm2xi.set_27pppppppp('272') 
        cm2xi.set_28pppppppp('282') 
        cm2xi.set_29pppppppp('292') 
        cm2xi.set_30pppppppp('302') 
        cm2xi.set_31pppppppp('312') 
        cm2xi.set_32pppppppp('322') 
        cm2xi.set_33pppppppp('332')  
        print(cm2xi.get_all())
        print("PHASE III/ Step 6/7 Done SET each individually")
    
        # ---------------------------------------------------------------------------------------------
        # GET each individually                             
        # ---------------------------------------------------------------------------------------------
    
        print('~' *33)
        time2xi = time4xi()
        print(time2xi)
        #1
        print(cm2xi.get_backlog())
        print(cm2xi.get_clear())
        print(cm2xi.get_create())  
        print(cm2xi.get_debug_info())
        print(cm2xi.get_dummy())
        print(cm2xi.get_error())
        print(cm2xi.get_exitpriority())
        print(cm2xi.get_getvalue())
        print(cm2xi.get_id())
        #11
        print(cm2xi.get_initial())
        print(cm2xi.get_is_set())
        print(cm2xi.get_number_of_objects())
        print(cm2xi.get_pickle())
        print(cm2xi.get_proxy())
        print(cm2xi.get_return())
        print(cm2xi.get_set())
        print(cm2xi.get_shutdown())
        print(cm2xi.get_started())
        #20
        print(cm2xi.get_stop())
        print(cm2xi.get_traceback())
        print(cm2xi.get_typeid())
        print(cm2xi.get_unserializable())
        print(cm2xi.get_value())
        print(cm2xi.get_wait())
        print(cm2xi.get_26pppppppp()) 
        print(cm2xi.get_27pppppppp()) 
        print(cm2xi.get_28pppppppp()) 
        print(cm2xi.get_29pppppppp()) 
        print(cm2xi.get_30pppppppp()) 
        print(cm2xi.get_31pppppppp()) 
        print(cm2xi.get_32pppppppp()) 
        print(cm2xi.get_33pppppppp())  
        
        print("PHASE III/ Step 7/7 each get with a get method")
        
    
        # ---------------------------------------------------------------------------------------------
        # SENSE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('SENSE')
        print('=' *33)      
        
        cm2xi.sense()
        
        # ---------------------------------------------------------------------------------------------
        # REASON                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('REASON')
        print('=' *33)       
        cm2xi.reason()
        
        # ---------------------------------------------------------------------------------------------
        # ACE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('ACE')
        print('=' *33)       
        cm2xi.ace()                
   
       
        # ---------------------------------------------------------------------------------------------
        # END OF TESTS                             
        # ---------------------------------------------------------------------------------------------                    
        print('~' *33)
        print("ALL TESTS COMPLETED")
        time2xi = time4xi()
        print(time2xi)
        
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
                   
        
#</function4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test constant_managers4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_constant_managers4xi() 
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
                   
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_constant_managers4xi.txt
#   sense-test-constant-managers4xi.xml
#   reason-test-constant-managers4xi.xml
#   ace-test-constant-managers4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 



#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_constant_managers4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

